﻿using System;
using System.Collections.Generic;
using System.Text;

namespace SPS2
{
    public class Log
    {
        public delegate void LogListener(Level level, string message);
        public enum Level
        {
            Trace,
            Debug,
            Info,
            Warn,
            Error,
            Fatal,
        };
        private static readonly log4net.ILog logger = log4net.LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);

        public Log()
        {
        }
        public event LogListener NewMessage;
        public void Write(Level level, string message)
        {
            System.Diagnostics.Debug.WriteLine(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " " + level + ": " + message);
            lock (logger)
            {
                if (NewMessage != null) NewMessage(level, message);
                switch (level)
                {
                    case Level.Trace:
#if DEBUG
                        logger.Debug(message);
#endif
                        break;
                    case Level.Warn:
                        logger.Warn(message);
                        break;
                    case Level.Info:
                        logger.Info(message);
                        break;
                    case Level.Debug:
                        logger.Debug(message);
                        break;
                    case Level.Error:
                        logger.Error(message);
                        break;
                    case Level.Fatal:
                        logger.Fatal(message);
                        break;
                    default:
                        System.Diagnostics.Debug.Assert(false, "不正なLog.Levelが指定されました");
                        break;
                }
            }
        }

    }
}
