﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;
using SdlDotNet.Graphics;

namespace SPS2
{
    public class Sprite
    {
        SurfaceGl surface;
        public Sprite(Surface s)
        {
            surface = new SurfaceGl(s, true);
        }
        public void Draw()
        {
            surface.Draw(-Width / 2.0f, -Height / 2.0f);
        }
        //private Surface Surface { get { return surface.Surface; } }
        public int Width { get { return surface.Surface.Width; } }
        public int Height { get { return surface.Surface.Height; } }

        public static Sprite RenderText(SdlDotNet.Graphics.Font font, char ch, Color color)
        {
            return new Sprite(font.Render(ch.ToString(), color, true));
        }
        public static List<Sprite> RenderText(SdlDotNet.Graphics.Font font, string text, Color color)
        {
            if (font == null)
            {
                throw new ArgumentNullException("font");
            }
            if (color == null)
            {
                throw new ArgumentNullException("color");
            }
            System.Diagnostics.Debug.Assert(text != null);
            List<Sprite> result = new List<Sprite>();
            if (text == null)
            {
                return result;
            }
            foreach (char c in text)
            {
                result.Add(RenderText(font, c, color));
            }
            return result;
        }
    }
}
